Index: Config.in
===================================================================
--- Config.in	(revision 174)
+++ Config.in	(working copy)
@@ -99,19 +99,6 @@
 	help
 		Specify the ROM size here in KB.
 
-config USE_LZMA
-	bool "Enable LZMA compression"
-	depends on !(PAYLOAD_OFW && COREBOOT_V2)
-	depends on !(PAYLOAD_FILO && COREBOOT_V2)
-	depends on !(PAYLOAD_ETHERBOOT && COREBOOT_V2)
-	default y
-	help
-	  Precompress the payload with LZMA when using coreboot v2. This doesn't
-	  work for FILO, OFW, or ETHERBOOT.
-
-	  When using COREBOOT_V3, parse the elf and have lar compress the files.
-	  This works with all ELF payloads.
-
 config CB_USE_BUILD
 	bool "Specify a coreboot build dir"
 	depends on ADVANCED
Index: config/platforms/tyan-s2881.conf
===================================================================
--- config/platforms/tyan-s2881.conf	(revision 174)
+++ config/platforms/tyan-s2881.conf	(working copy)
@@ -38,8 +38,6 @@
 
 COREBOOT_VENDOR=tyan
 COREBOOT_BOARD=s2881
-CBV2_CONFIG=Config.lb
-CBV2_PAYLOAD_FILE_EXT=elf
 CBV2_TDIR=s2881
 CBV2_TAG=3131
 
Index: config/platforms/tyan-s2882.conf
===================================================================
--- config/platforms/tyan-s2882.conf	(revision 174)
+++ config/platforms/tyan-s2882.conf	(working copy)
@@ -38,8 +38,6 @@
 
 COREBOOT_VENDOR=tyan
 COREBOOT_BOARD=s2882
-CBV2_CONFIG=Config.lb
-CBV2_PAYLOAD_FILE_EXT=elf
 CBV2_TDIR=s2882
 CBV2_TAG=3114
 
Index: config/platforms/tyan-s2891.conf
===================================================================
--- config/platforms/tyan-s2891.conf	(revision 174)
+++ config/platforms/tyan-s2891.conf	(working copy)
@@ -38,8 +38,6 @@
 
 COREBOOT_VENDOR=tyan
 COREBOOT_BOARD=s2891
-CBV2_CONFIG=Config.lb
-CBV2_PAYLOAD_FILE_EXT=elf
 CBV2_TDIR=s2891
 CBV2_TAG=3259
 
Index: config/platforms/tyan-s2892.conf
===================================================================
--- config/platforms/tyan-s2892.conf	(revision 174)
+++ config/platforms/tyan-s2892.conf	(working copy)
@@ -36,8 +36,6 @@
 
 COREBOOT_VENDOR=tyan
 COREBOOT_BOARD=s2892
-CBV2_CONFIG=Config.lb
-CBV2_PAYLOAD_FILE_EXT=elf
 CBV2_TDIR=s2892
 CBV2_TAG=3259
 
Index: config/platforms/dbe61.conf
===================================================================
--- config/platforms/dbe61.conf	(revision 174)
+++ config/platforms/dbe61.conf	(working copy)
@@ -29,8 +29,6 @@
 
 COREBOOT_VENDOR=artecgroup
 COREBOOT_BOARD=dbe61
-CBV2_CONFIG=Config.lb
-CBV2_PAYLOAD_FILE_EXT=elf
 CBV2_TDIR=dbe61
 CBV2_TAG=3090
 
Index: config/platforms/asus_a8v-e_se.conf
===================================================================
--- config/platforms/asus_a8v-e_se.conf	(revision 174)
+++ config/platforms/asus_a8v-e_se.conf	(working copy)
@@ -41,8 +41,6 @@
 
 COREBOOT_VENDOR=asus
 COREBOOT_BOARD=a8v-e_se
-CBV2_CONFIG=Config.lb
-CBV2_PAYLOAD_FILE_EXT=elf
 CBV2_TDIR=asus_a8v-e_se
 CBV2_TAG=3241
 
Index: config/platforms/ga-2761gxdk.conf
===================================================================
--- config/platforms/ga-2761gxdk.conf	(revision 174)
+++ config/platforms/ga-2761gxdk.conf	(working copy)
@@ -34,8 +34,6 @@
 
 COREBOOT_VENDOR=gigabyte
 COREBOOT_BOARD=ga_2761gxdk
-CBV2_CONFIG=Config.lb
-CBV2_PAYLOAD_FILE_EXT=elf
 CBV2_TDIR=ga_2761gxdk
 CBV2_TAG=3092
 
Index: config/platforms/msm800sev.conf
===================================================================
--- config/platforms/msm800sev.conf	(revision 174)
+++ config/platforms/msm800sev.conf	(working copy)
@@ -28,8 +28,6 @@
 
 COREBOOT_VENDOR=digitallogic
 COREBOOT_BOARD=msm800sev
-CBV2_CONFIG=Config.lb
-CBV2_PAYLOAD_FILE_EXT=elf
 CBV2_TDIR=msm800sev
 CBV2_TAG=3079
 
Index: config/platforms/tyan-s2895.conf
===================================================================
--- config/platforms/tyan-s2895.conf	(revision 174)
+++ config/platforms/tyan-s2895.conf	(working copy)
@@ -36,8 +36,6 @@
 
 COREBOOT_VENDOR=tyan
 COREBOOT_BOARD=s2895
-CBV2_CONFIG=Config.lb
-CBV2_PAYLOAD_FILE_EXT=elf
 CBV2_TDIR=s2895
 CBV2_TAG=3259
 
Index: config/platforms/serengeti_cheetah.conf
===================================================================
--- config/platforms/serengeti_cheetah.conf	(revision 174)
+++ config/platforms/serengeti_cheetah.conf	(working copy)
@@ -43,8 +43,6 @@
 # coreboot configuration
 
 COREBOOT_VENDOR=amd
-CBV2_CONFIG=Config.lb
-CBV2_PAYLOAD_FILE_EXT=elf
 
 CBV3_TAG=HEAD
 
Index: config/platforms/qemu.conf
===================================================================
--- config/platforms/qemu.conf	(revision 174)
+++ config/platforms/qemu.conf	(working copy)
@@ -25,8 +25,6 @@
 
 # coreboot-v2 configuration
 CBV2_TAG=3241
-CBV2_CONFIG=Config.lb
-CBV2_PAYLOAD_FILE_EXT=elf
 CBV2_TDIR=qemu-x86
 
 # coreboot v3 configuration
Index: config/platforms/supermicro-h8dmr.conf
===================================================================
--- config/platforms/supermicro-h8dmr.conf	(revision 174)
+++ config/platforms/supermicro-h8dmr.conf	(working copy)
@@ -38,8 +38,6 @@
 
 COREBOOT_VENDOR=supermicro
 COREBOOT_BOARD=h8dmr
-CBV2_CONFIG=Config.lb
-CBV2_PAYLOAD_FILE_EXT=elf
 CBV2_TDIR=h8dmr
 CBV2_TAG=3092
 
Index: config/platforms/norwich.conf
===================================================================
--- config/platforms/norwich.conf	(revision 174)
+++ config/platforms/norwich.conf	(working copy)
@@ -28,8 +28,6 @@
 
 COREBOOT_VENDOR=amd
 COREBOOT_BOARD=norwich
-CBV2_CONFIG=Config.lb
-CBV2_PAYLOAD_FILE_EXT=elf
 CBV2_TDIR=norwich
 CBV2_TAG=3090
 
Index: config/platforms/db800.conf
===================================================================
--- config/platforms/db800.conf	(revision 174)
+++ config/platforms/db800.conf	(working copy)
@@ -30,8 +30,6 @@
 
 COREBOOT_VENDOR=amd
 COREBOOT_BOARD=db800
-CBV2_CONFIG=Config.lb
-CBV2_PAYLOAD_FILE_EXT=elf
 CBV2_TDIR=db800
 CBV2_TAG=3090
 
Index: config/platforms/m57sli.conf
===================================================================
--- config/platforms/m57sli.conf	(revision 174)
+++ config/platforms/m57sli.conf	(working copy)
@@ -38,8 +38,6 @@
 
 COREBOOT_VENDOR=gigabyte
 COREBOOT_BOARD=m57sli
-CBV2_CONFIG=Config.lb
-CBV2_PAYLOAD_FILE_EXT=elf
 CBV2_TDIR=m57sli
 CBV2_TAG=3118
 
Index: config/platforms/alix1c.conf
===================================================================
--- config/platforms/alix1c.conf	(revision 174)
+++ config/platforms/alix1c.conf	(working copy)
@@ -27,8 +27,6 @@
 
 COREBOOT_VENDOR=pcengines
 COREBOOT_BOARD=alix1c
-CBV2_CONFIG=Config.lb
-CBV2_PAYLOAD_FILE_EXT=elf
 CBV2_TDIR=alix1c
 CBV2_TAG=3079
 
Index: config/payloads/Config.in
===================================================================
--- config/payloads/Config.in	(revision 174)
+++ config/payloads/Config.in	(working copy)
@@ -3,6 +3,16 @@
 
 menu "Payload Configuration"
 
+config USE_LZMA
+	bool "Enable LZMA compression"
+	default y
+	help
+	  Precompress the payload with LZMA when using coreboot v2. This changes
+	  the Config.lb file used.
+
+	  When using COREBOOT_V3, parse the elf and have lar compress the files.
+	  This works with all ELF payloads.
+
 choice
 	prompt "Desired payload"
 	default PAYLOAD_KERNEL
Index: packages/coreboot-v2/generic.mk
===================================================================
--- packages/coreboot-v2/generic.mk	(revision 174)
+++ packages/coreboot-v2/generic.mk	(working copy)
@@ -1,20 +1,5 @@
 # This is the Generic coreboot target
 
-ifeq ($(CONFIG_PAYLOAD_OFW),y)
-	CBV2_CONFIG=Config-lab.lb
-	CBV2_PAYLOAD_FILE_EXT=elf.lzma
-endif
-
-ifeq ($(CONFIG_PAYLOAD_KERNEL),y)
-	CBV2_CONFIG=Config-lab.lb
-	CBV2_PAYLOAD_FILE_EXT=elf.lzma
-endif
-
-ifeq ($(CONFIG_PAYLOAD_LAB),y)
-	CBV2_CONFIG=Config-lab.lb
-	CBV2_PAYLOAD_FILE_EXT=elf.lzma
-endif
-
 include $(PACKAGE_DIR)/coreboot-v2/coreboot.inc
 
 coreboot: generic-coreboot
Index: packages/coreboot-v2/coreboot.inc
===================================================================
--- packages/coreboot-v2/coreboot.inc	(revision 174)
+++ packages/coreboot-v2/coreboot.inc	(working copy)
@@ -1,5 +1,13 @@
 # This is the common code included by all the targets
 
+ifeq ($(CONFIG_USE_LZMA),y)
+	CBV2_CONFIG=Config-lab.lb
+	CBV2_PAYLOAD_FILE_EXT=elf.lzma
+else
+	CBV2_CONFIG=Config.lb
+	CBV2_PAYLOAD_FILE_EXT=elf
+endif
+
 ifeq ($(CONFIG_CB_CUSTOM_REV),y)
 $(warning Using custom rev $(CONFIG_CB_REVISION))
 CBV2_TAG=$(CONFIG_CB_REVISION)