--- bez_ME	2017-04-18 15:54:31.275705675 +0200
+++ s_ME	2017-04-18 15:52:09.000000000 +0200
@@ -1,4 +1,4 @@
-mobile = 0
+mobile = 1
 tCK = 320
 tAA = 3360
 tWR = 12
@@ -38,14 +38,14 @@
 timings[0][0].val_320c = -18
 timings[0][0].lanes[0].timA = 75
 timings[0][0].lanes[0].rising = 37
-timings[0][0].lanes[0].falling = 37
+timings[0][0].lanes[0].falling = 38
 timings[0][0].lanes[0].timC = 29
 timings[0][0].lanes[0].timB = 192
-timings[0][0].lanes[1].timA = 48
+timings[0][0].lanes[1].timA = 49
 timings[0][0].lanes[1].rising = 32
 timings[0][0].lanes[1].falling = 36
-timings[0][0].lanes[1].timC = 84
-timings[0][0].lanes[1].timB = 183
+timings[0][0].lanes[1].timC = 83
+timings[0][0].lanes[1].timB = 182
 timings[0][0].lanes[2].timA = 99
 timings[0][0].lanes[2].rising = 32
 timings[0][0].lanes[2].falling = 33
@@ -56,11 +56,11 @@
 timings[0][0].lanes[3].falling = 36
 timings[0][0].lanes[3].timC = 68
 timings[0][0].lanes[3].timB = 168
-timings[0][0].lanes[4].timA = 184
-timings[0][0].lanes[4].rising = 31
+timings[0][0].lanes[4].timA = 185
+timings[0][0].lanes[4].rising = 30
 timings[0][0].lanes[4].falling = 32
-timings[0][0].lanes[4].timC = 39
-timings[0][0].lanes[4].timB = 328
+timings[0][0].lanes[4].timC = 37
+timings[0][0].lanes[4].timB = 327
 timings[0][0].lanes[5].timA = 121
 timings[0][0].lanes[5].rising = 33
 timings[0][0].lanes[5].falling = 36
@@ -68,10 +68,10 @@
 timings[0][0].lanes[5].timB = 256
 timings[0][0].lanes[6].timA = 161
 timings[0][0].lanes[6].rising = 32
-timings[0][0].lanes[6].falling = 35
+timings[0][0].lanes[6].falling = 34
 timings[0][0].lanes[6].timC = 65
-timings[0][0].lanes[6].timB = 293
-timings[0][0].lanes[7].timA = 156
+timings[0][0].lanes[6].timB = 292
+timings[0][0].lanes[7].timA = 155
 timings[0][0].lanes[7].rising = 34
 timings[0][0].lanes[7].falling = 39
 timings[0][0].lanes[7].timC = 43
@@ -81,130 +81,130 @@
 timings[0][1].val_320c = -16
 timings[0][1].lanes[0].timA = 77
 timings[0][1].lanes[0].rising = 35
-timings[0][1].lanes[0].falling = 36
+timings[0][1].lanes[0].falling = 37
 timings[0][1].lanes[0].timC = 29
 timings[0][1].lanes[0].timB = 192
 timings[0][1].lanes[1].timA = 49
 timings[0][1].lanes[1].rising = 30
 timings[0][1].lanes[1].falling = 33
-timings[0][1].lanes[1].timC = 83
-timings[0][1].lanes[1].timB = 181
+timings[0][1].lanes[1].timC = 82
+timings[0][1].lanes[1].timB = 180
 timings[0][1].lanes[2].timA = 98
 timings[0][1].lanes[2].rising = 31
-timings[0][1].lanes[2].falling = 30
+timings[0][1].lanes[2].falling = 31
 timings[0][1].lanes[2].timC = 69
 timings[0][1].lanes[2].timB = 231
-timings[0][1].lanes[3].timA = 27
-timings[0][1].lanes[3].rising = 30
-timings[0][1].lanes[3].falling = 33
-timings[0][1].lanes[3].timC = 69
-timings[0][1].lanes[3].timB = 168
-timings[0][1].lanes[4].timA = 185
+timings[0][1].lanes[3].timA = 26
+timings[0][1].lanes[3].rising = 31
+timings[0][1].lanes[3].falling = 32
+timings[0][1].lanes[3].timC = 68
+timings[0][1].lanes[3].timB = 167
+timings[0][1].lanes[4].timA = 186
 timings[0][1].lanes[4].rising = 28
 timings[0][1].lanes[4].falling = 31
-timings[0][1].lanes[4].timC = 35
-timings[0][1].lanes[4].timB = 326
+timings[0][1].lanes[4].timC = 34
+timings[0][1].lanes[4].timB = 325
 timings[0][1].lanes[5].timA = 116
-timings[0][1].lanes[5].rising = 32
-timings[0][1].lanes[5].falling = 36
+timings[0][1].lanes[5].rising = 31
+timings[0][1].lanes[5].falling = 35
 timings[0][1].lanes[5].timC = 27
 timings[0][1].lanes[5].timB = 256
 timings[0][1].lanes[6].timA = 159
 timings[0][1].lanes[6].rising = 30
-timings[0][1].lanes[6].falling = 31
+timings[0][1].lanes[6].falling = 32
 timings[0][1].lanes[6].timC = 60
-timings[0][1].lanes[6].timB = 289
-timings[0][1].lanes[7].timA = 155
-timings[0][1].lanes[7].rising = 32
+timings[0][1].lanes[6].timB = 288
+timings[0][1].lanes[7].timA = 154
+timings[0][1].lanes[7].rising = 31
 timings[0][1].lanes[7].falling = 36
-timings[0][1].lanes[7].timC = 40
-timings[0][1].lanes[7].timB = 270
+timings[0][1].lanes[7].timC = 39
+timings[0][1].lanes[7].timB = 269
 timings[1][0].val_4024 = 40
 timings[1][0].val_4028 = 3
-timings[1][0].val_320c = -19
-timings[1][0].lanes[0].timA = 102
-timings[1][0].lanes[0].rising = 28
-timings[1][0].lanes[0].falling = 31
-timings[1][0].lanes[0].timC = 45
-timings[1][0].lanes[0].timB = 207
-timings[1][0].lanes[1].timA = 77
-timings[1][0].lanes[1].rising = 29
-timings[1][0].lanes[1].falling = 30
+timings[1][0].val_320c = -20
+timings[1][0].lanes[0].timA = 101
+timings[1][0].lanes[0].rising = 30
+timings[1][0].lanes[0].falling = 33
+timings[1][0].lanes[0].timC = 43
+timings[1][0].lanes[0].timB = 206
+timings[1][0].lanes[1].timA = 76
+timings[1][0].lanes[1].rising = 32
+timings[1][0].lanes[1].falling = 33
 timings[1][0].lanes[1].timC = 35
 timings[1][0].lanes[1].timB = 199
 timings[1][0].lanes[2].timA = 119
-timings[1][0].lanes[2].rising = 29
-timings[1][0].lanes[2].falling = 30
-timings[1][0].lanes[2].timC = 76
+timings[1][0].lanes[2].rising = 31
+timings[1][0].lanes[2].falling = 33
+timings[1][0].lanes[2].timC = 77
 timings[1][0].lanes[2].timB = 239
 timings[1][0].lanes[3].timA = 54
-timings[1][0].lanes[3].rising = 29
-timings[1][0].lanes[3].falling = 29
-timings[1][0].lanes[3].timC = 83
+timings[1][0].lanes[3].rising = 32
+timings[1][0].lanes[3].falling = 33
+timings[1][0].lanes[3].timC = 82
 timings[1][0].lanes[3].timB = 179
 timings[1][0].lanes[4].timA = 207
-timings[1][0].lanes[4].rising = 29
-timings[1][0].lanes[4].falling = 30
-timings[1][0].lanes[4].timC = 35
-timings[1][0].lanes[4].timB = 325
-timings[1][0].lanes[5].timA = 148
-timings[1][0].lanes[5].rising = 27
-timings[1][0].lanes[5].falling = 30
-timings[1][0].lanes[5].timC = 29
+timings[1][0].lanes[4].rising = 32
+timings[1][0].lanes[4].falling = 33
+timings[1][0].lanes[4].timC = 33
+timings[1][0].lanes[4].timB = 324
+timings[1][0].lanes[5].timA = 147
+timings[1][0].lanes[5].rising = 29
+timings[1][0].lanes[5].falling = 32
+timings[1][0].lanes[5].timC = 30
 timings[1][0].lanes[5].timB = 256
-timings[1][0].lanes[6].timA = 182
-timings[1][0].lanes[6].rising = 30
-timings[1][0].lanes[6].falling = 34
-timings[1][0].lanes[6].timC = 61
+timings[1][0].lanes[6].timA = 181
+timings[1][0].lanes[6].rising = 33
+timings[1][0].lanes[6].falling = 37
+timings[1][0].lanes[6].timC = 62
 timings[1][0].lanes[6].timB = 290
 timings[1][0].lanes[7].timA = 179
-timings[1][0].lanes[7].rising = 28
-timings[1][0].lanes[7].falling = 31
-timings[1][0].lanes[7].timC = 46
-timings[1][0].lanes[7].timB = 273
+timings[1][0].lanes[7].rising = 31
+timings[1][0].lanes[7].falling = 34
+timings[1][0].lanes[7].timC = 47
+timings[1][0].lanes[7].timB = 274
 timings[1][1].val_4024 = 40
 timings[1][1].val_4028 = 3
-timings[1][1].val_320c = -24
-timings[1][1].lanes[0].timA = 106
+timings[1][1].val_320c = -22
+timings[1][1].lanes[0].timA = 105
 timings[1][1].lanes[0].rising = 33
-timings[1][1].lanes[0].falling = 35
-timings[1][1].lanes[0].timC = 45
-timings[1][1].lanes[0].timB = 208
+timings[1][1].lanes[0].falling = 36
+timings[1][1].lanes[0].timC = 44
+timings[1][1].lanes[0].timB = 207
 timings[1][1].lanes[1].timA = 78
 timings[1][1].lanes[1].rising = 33
 timings[1][1].lanes[1].falling = 35
-timings[1][1].lanes[1].timC = 36
-timings[1][1].lanes[1].timB = 200
-timings[1][1].lanes[2].timA = 123
+timings[1][1].lanes[1].timC = 35
+timings[1][1].lanes[1].timB = 199
+timings[1][1].lanes[2].timA = 124
 timings[1][1].lanes[2].rising = 33
 timings[1][1].lanes[2].falling = 35
-timings[1][1].lanes[2].timC = 83
-timings[1][1].lanes[2].timB = 246
+timings[1][1].lanes[2].timC = 82
+timings[1][1].lanes[2].timB = 245
 timings[1][1].lanes[3].timA = 58
-timings[1][1].lanes[3].rising = 34
+timings[1][1].lanes[3].rising = 33
 timings[1][1].lanes[3].falling = 34
-timings[1][1].lanes[3].timC = 91
-timings[1][1].lanes[3].timB = 187
+timings[1][1].lanes[3].timC = 90
+timings[1][1].lanes[3].timB = 186
 timings[1][1].lanes[4].timA = 209
 timings[1][1].lanes[4].rising = 33
-timings[1][1].lanes[4].falling = 34
+timings[1][1].lanes[4].falling = 35
 timings[1][1].lanes[4].timC = 39
 timings[1][1].lanes[4].timB = 329
 timings[1][1].lanes[5].timA = 150
 timings[1][1].lanes[5].rising = 31
-timings[1][1].lanes[5].falling = 34
+timings[1][1].lanes[5].falling = 35
 timings[1][1].lanes[5].timC = 31
 timings[1][1].lanes[5].timB = 258
 timings[1][1].lanes[6].timA = 186
 timings[1][1].lanes[6].rising = 36
 timings[1][1].lanes[6].falling = 38
-timings[1][1].lanes[6].timC = 65
-timings[1][1].lanes[6].timB = 294
-timings[1][1].lanes[7].timA = 182
+timings[1][1].lanes[6].timC = 63
+timings[1][1].lanes[6].timB = 292
+timings[1][1].lanes[7].timA = 185
 timings[1][1].lanes[7].rising = 33
 timings[1][1].lanes[7].falling = 36
-timings[1][1].lanes[7].timC = 53
-timings[1][1].lanes[7].timB = 280
+timings[1][1].lanes[7].timC = 51
+timings[1][1].lanes[7].timB = 277
 info.dimm[0][0].cas_supported = 254
 info.dimm[0][0].flags = operable_1_50V dll_off_mode rzq6_supported rzq7_supported ext_temp_refresh
 info.dimm[0][0].width = 8